
/************************************************************************
* Copyright (c) 1995 Valentin Shopov, Blagoevgrad, Bulgaria		*
*									*
* Permission to use, copy, modify, and distribute this material for any	*
* purpose and without fee is hereby granted, provided that the above	*
* copyright notice and this permission notice appear in all copies, and	*
* that the name of the author not be used in advertising or publicity 	*
* pertaining to this material without the specific, prior written 	*
* permission of the author.						*
*									*
* THE AUTHOR MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY	*  
* OF THIS MATERIAL FOR ANY PURPOSE. IT IS PROVIDED "AS IS", WITHOUT ANY	* 
* EXPRESS OR IMPLIED WARRANTIES.					*
*************************************************************************/

/**************************ciilib2.1.7***********************************
 *									*
 *        Character to Inline Image Conversion Library (CIILIB)		*
 *									*
 *	Encoder for Character by Inline Image of HTML on HTTP		*
 *			by Valentin Shopov				*
 *			valentin@rs.aubg.bg				*
 ************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include <memory.h>
#include "cii.h"
extern char *strstr ();

/*////////////////////////////////////////////////////////////////////// */


/*
 *    CII output image type selector
 */
CII_setitype (sitype)
	char *sitype;
{
	;
}

/*
 *    text to CII encoder
 */
static char *URL_of_src = 0;
static int gotEOF = 0;

CII_toCII (any_text, cii_text, ctype, charsets, urlbase, srcurl)
	unsigned char *any_text, *cii_text;
	char *ctype, *charsets[];
	char *urlbase, *srcurl;
{
	static _CII_toCII ();
	URL_of_src = srcurl;
	_CII_toCII (any_text, cii_text, ctype, charsets, urlbase, srcurl);
	URL_of_src = 0;
}


static int isTag, isTitle, isBody, isFrame, isHtml, isScript, isComment,
  isAnchor, isMozilla, TagBufLen;
static int isKOI;
static char *Hchar = "k";
static unsigned char TagBuf[2048];
static char formbuf[2048];
static char CII_FLAGS[256];
static char URLcharcode[64];
static int initDone = 0;
extern struct CharCodesXBM CII_CC[];

static struct CIIoptions CII_O =
{"", 30, 0, 0, 0, 0, 0, 0, 0, 0};


static int txColor = 0x000000;
static int lkColor = 0x0000ee;
static char *Pchar = "N";

char *
ShowCP (frmbuf)
	char *frmbuf;
{
	static char *isCHK[] =
	{"", "CHECKED"};
	char *aftercp;
	*frmbuf = 0;
	if (URL_of_src && strncasecmp (URL_of_src, "file://localhost/", 17)) {
		sprintf (frmbuf, "\
<HR><HR>\
<H3>CIILIB Control Panel</H3>\n\
<FORM ACTION=\"/-_-http://-/\" METHOD=GET>\n\
<PRE>\n\
<INPUT NAME = \"/cc.ii.cc\" VALUE=\"%s\" SIZE=\"12\"> CharCode                <INPUT NAME=\"gw\" VALUE=\"%d\" SIZE=\"3\"> Image Width\n\
             <INPUT TYPE=checkbox %s NAME=\"ul\" VALUE=\"y\"> Underlined Anchors         <INPUT TYPE=checkbox %s NAME=\"us\" VALUE=\"y\"> Underlined spaces\n\
             <INPUT TYPE=checkbox %s NAME=\"sk\" VALUE=\"y\"> Short Kana                 <INPUT TYPE=checkbox %s NAME=\"sc\" VALUE=\"y\"> Short Chars\n\
             <INPUT TYPE=checkbox %s NAME=\"bx\" VALUE=\"y\"> Black text as XBM          <INPUT TYPE=checkbox %s NAME=\"cp\" VALUE=\"y\"> Show Control Panel\n\
<INPUT TYPE=hidden NAME=\"url\" VALUE=\"/%s\">\
<INPUT TYPE=submit VALUE=\"Reload\">\
    <INPUT TYPE=reset>\
    <A HREF=\"/-/cii/info\">CIILIB Info</A>\
</PRE>\n\
</FORM><HR><HR>\n\
", CII_O.charcode, CII_O.gwidth, isCHK[CII_O.uline], isCHK[CII_O.uspc], isCHK[CII_O.skana], isCHK[CII_O.schar], isCHK[CII_O.b2xbm], isCHK[CII_O.showcp], URL_of_src ? URL_of_src : "");
	}
	return frmbuf;
}


static int
CharsetIDh (abbr, height)
	char *abbr;
{
	int i;
	char *nick;

	for (i = 0; nick = CII_CC[i].name; i++) {
		if (height == 0 || CII_CC[i].height == height) {
			if (strncasecmp (nick, abbr, strlen (abbr)) == 0)
				return i;
			if (strcasecmp (abbr, CII_CC[i].regname) == 0)
				return i;
		}
	}
	return -1;
}

static int
CharsetID (abbr)
	char *abbr;
{
	return CharsetIDh (abbr, 0);
}

static int
to256c (csname)
	char *csname;
{
	int cc_id;

	if ((cc_id = CharsetID (csname)) == -1)
		return 0;
	return CII_CC[cc_id].is2bytes == 0;
}


static unsigned char
koi8tocyr (kchar)
	unsigned char kchar;
{
	char *cyrch = "\356\320\321\346\324\325\344\323\345\330\331\332\333\334\
\335\336\337\357\340\341\342\343\326\322\354\353\327\350\355\351\347\352";
	if (kchar >= 0xc0 && kchar <= 0xdf)
		return cyrch[kchar - 0xc0];
	else if (kchar >= 0xe0 && kchar <= 0xff)
		return cyrch[kchar - 0xe0] - 32;
	else
		return kchar;
}



static int
strncscmp (str1, str2, snum)
	char *str1, *str2;
	int snum;
{
	char ch1;
	int i, j, isSPC;
	for (i = 0, j = 0, isSPC = 0; i < snum && str1[j]; i++) {
		for (; str1[j] <= ' ' && str1[j];) {
			j++;
			isSPC = 1;
		}
		ch1 = str1[j];
		if (ch1 >= 'a' && ch1 <= 'z')
			ch1 -= 32;
		if (isSPC) {
			isSPC = 0;
			if (ch1 == '=' && str2[i] == '=') {
				j++;
				continue;
			}
			if (str2[i - 1] == '=') {
				i--;
				continue;
			}
			if (ch1 == '>' && str2[i] == '>') {
				j++;
				continue;
			}

			if (str2[i] != ' ')
				return 1;
		}
		else {
			if (str2[i] != ch1)
				return 1;
			j++;
		}
	}
	return 0;
}

GIFCII_setccid (Hsize, charset)
	int Hsize;
	char *charset;
{
	int cc_id;

	switch (Hsize) {
	case 'h':
		if ((cc_id = CharsetIDh (charset, 24)) == -1)
			cc_id = CharsetIDh (charset, 14);
		break;
	case 'i':
		if ((cc_id = CharsetIDh (charset, 16)) == -1)
			cc_id = CharsetIDh (charset, 14);
		break;
	case 'j':
	case 'k':
		if ((cc_id = CharsetIDh (charset, 14)) == -1)
			cc_id = CharsetIDh (charset, 16);
		break;
	default:
		return -1;
	}

	if (cc_id == -1)
		cc_id = CharsetID (charset);

	return cc_id;
}

static
GIFCII_setfsize (chHp, chWp, Acharp, charset)
	int *chHp, *chWp;
	char **Acharp;
	char *charset;
{
	int cc_id;

	cc_id = GIFCII_setccid (*Hchar, charset);
	*chHp = CII_CC[cc_id].height;
	*chWp = CII_CC[cc_id].width;

	*Acharp = "";
	if (CII_O.uline)
		if (isAnchor && isMozilla) {
			*Acharp = "u";
			*chHp += 2;
		}
}

static int
GIFCII_switch_H (sp)
	char *sp;
{
	static int isHdr[6];
	static char HdrIn[] = "<H1";
	static char HdrOut[] = "</H1";
	static char *HcharAr[6] =
	{"h", "i", "j", "j", "j", "j"};
	int i;

	for (i = 0; i < 6; i++) {
		HdrIn[2] = HdrOut[3] = '1' + i;
		if (!isHdr[i] && !strncscmp (sp, HdrIn, sizeof (HdrIn) - 1)) {
			isHdr[i] = 1;
			Hchar = HcharAr[i];
			return 1;
		}
		if (isHdr[i] && !strncscmp (sp, HdrOut, sizeof (HdrOut) - 1)) {
			isHdr[i] = 0;
			Hchar = "k";
			return 1;
		}
	}

	return 0;
}

static int
getColor (colorp, sp)
	int *colorp;
	char *sp;
{
	int i = 6, j, color = 0;

	while (sp[i] == ' ' || sp[i] == '\t')
		i++;
	if (sp[i] == '\"')
		i++;
	if (sp[i] == '#')
		i++;

	for (j = i; j < i + 6; j++) {
		if (sp[j] == 0 || sp[j] == ' ' || sp[j] == '\"' || sp[j] == '\n')
			break;

		color *= 0x10;

		if (sp[j] >= '0' && sp[j] <= '9')
			color += sp[j] - '0';
		else if (sp[j] >= 'A' && sp[j] <= 'F')
			color += sp[j] - 'A' + 10;
		else if (sp[j] >= 'a' && sp[j] <= 'f')
			color += sp[j] - 'a' + 10;
	}

	*colorp = color;
	return j - 1;
}

static
GIFCII_switch_Color (sp)
	char *sp;
{
	if (isMozilla) {
		int isText = 0, isLink = 0, i;
		for (i = 0; sp[i] != '>' && sp[i]; i++) {
			if (sp[i] == ' ' || sp[i] == '\"' || sp[i] == '\n') {
				if (!strncscmp (sp + i + 1, "BACKGROUND=", 11))
					Pchar = "I";
				if (!isText && !strncscmp (sp + i + 1, "TEXT=", 5)) {
					isText = 1;
					i += getColor (&txColor, sp + i);
				}
				if (!isLink && !strncscmp (sp + i + 1, "LINK=", 5)) {
					isLink = 1;
					i += getColor (&lkColor, sp + i);
				}
			}
		}
	}
}

static
GIFCII_putCII (dp, sp, ubase, charsetC, isLAP)
	unsigned char *dp, *sp;
	char *ubase, *charsetC;
{
	unsigned char c0, c1;
	int w, firstloop = 1, chH, chW;
	int do256, csID, isJP;
	char *charset;
	char *Achar;
	char *Gchar;
	Gchar = (CII_O.b2xbm && !(isAnchor ? lkColor : txColor)) ? "x" : "";

	if (!*sp)
		return;

	do256 = to256c (charsetC);
	csID = CharsetID (isKOI == 1 ? "cyr" : charsetC);
	if (csID == -1) {
		strcpy (dp, sp);
		return;
	}
	charset = CII_CC[csID].regname;
	isJP = (csID == CharsetID ("jp"));

	GIFCII_setfsize (&chH, &chW, &Achar, charset);
	if (*Hchar == 'h' && chH < 24) {
		chW <<= 1;
		chH <<= 1;
	}

	for (w = 0;; w++) {
		if (!do256 && !sp[1])
			sp++;

		if (!firstloop && (w == CII_O.gwidth && !isLAP || w == 0 || !*sp)) {
			if (isMozilla) {
				sprintf (dp, "\" WIDTH=%d HEIGHT=%d%s>",
					 chW * ((w == 0 || isLAP) ? 1 : w),
					 chH, isAnchor ? " BORDER=0" : "");
			}
			else
				sprintf (dp, "\">");
			dp += strlen (dp);
			w = 0;
			if (!*sp)
				break;
		}

		if (w == 0) {
			sprintf (dp, "<IMG SRC=\"%s%s/%06x%s%s%s%s", ubase, charset,
				 (isAnchor ? lkColor : txColor), Pchar, Gchar, Hchar, Achar);
			dp += strlen (dp);
			if (isLAP)
				*dp++ = '+';
		}

		if (do256) {
			c0 = 0;
			c1 = (isKOI == 1) ? koi8tocyr (*sp) : *sp;
			sp++;
		}
		else {
			c0 = *sp++;
			c1 = *sp++;
		}
		sprintf (dp, "%02x%02x", c0, c1);
		dp += 4;

		if (CII_O.schar)
			if (!isLAP && do256 && !isAnchor && *Hchar == 'k')
				w = -1;

		if (CII_O.skana)
			if (isJP && !isAnchor && *Hchar == 'k')
				if ((c0 >= 0xa1 && c0 <= 0xa8)
				    || (sp[0] >= 0xa1 && sp[0] <= 0xa8 && (sp[1] & 0x80)))
					w = -1;

		if (CII_O.uspc)
			if (isAnchor && *sp == ' ') {
				for (; (w + 1) < CII_O.gwidth && *sp == ' '; w++) {
					sprintf (dp, "USPC");
					sp++;
					dp += 4;
				}
			}
		firstloop = 0;
	}
	return;
}

static
ASCII_TO_CII (src, dst)
	unsigned char *src, *dst;
{
	register unsigned char *sp, *dp;
	char *charset, *Achar, *ltPTR, *gtPTR;
	int i, chW, chH;
	int ignoreTagBuf = 0;

	if (TagBufLen + strlen (src) < sizeof (TagBuf) && !isScript && !isComment) {
		ltPTR = (char *) strrchr (src, '<');
		gtPTR = (char *) strrchr (src, '>');
		if ((gtPTR && ltPTR - gtPTR > 0) || ((TagBufLen || ltPTR) && !gtPTR)) {
			for (i = 0; src[i]; i++) {
				TagBuf[TagBufLen++] = src[i];
			}
			TagBuf[TagBufLen] = '\0';
			*dst = '\0';
			return;
		}

		if (TagBufLen) {
			for (i = 0; src[i]; i++) {
				TagBuf[TagBufLen++] = src[i];
			}
			TagBuf[TagBufLen] = '\0';
		}
	}
	else
		ignoreTagBuf = 1;

      SRC_conv:
	if (gotEOF && initDone == 1 && !isComment && !isScript) {
		if (0 < CII_O.showcp)
			sprintf (dst, "%s", ShowCP (formbuf));
		initDone = 2;
		return;
	}

	for (sp = (TagBufLen) ? TagBuf : src, dp = dst; *sp;) {
		if (*sp == '<' && !isTag && !CII_O.isplain) {
			if (!isScript && !isComment)
				isTag = 1;
			if (!isScript && !strncscmp (sp, "<SCRIPT", 7))
				isScript = 1;
			else if (isScript && !strncscmp (sp, "</SCRIPT>", 9)) {
				isScript = 0;
				isTag = 1;
			}
			else if (!isComment && !strncmp (sp, "<!--", 4)) {
				*dp++ = *sp++;
				*dp++ = *sp++;
				*dp++ = *sp++;
				*dp++ = *sp++;
				isComment = 1;
				isTag = 0;
			}
			else if (!isScript && !isComment)
				if (GIFCII_switch_H (sp));
				else if (!isBody && !strncscmp (sp, "<BODY", 5)) {
					isBody = 1;
					GIFCII_switch_Color (sp, isMozilla);
				}
				else if (isBody && !strncscmp (sp, "</BODY>", 7)) {
					isBody = 0;
					if (initDone == 1) {
						if (0 < CII_O.showcp) {
							sprintf (dp, "%s", ShowCP (formbuf));
							dp += strlen (dp);
						}
						initDone = 2;
					}
				}

				else if (!isAnchor && !strncscmp (sp, "<A HREF=", 8)) {
					isAnchor = 1;
				}
				else if (isAnchor && !strncscmp (sp, "</A>", 4)) {
					isAnchor = 0;
					isTag = 0;
				}
				else if (!isTitle && !strncscmp (sp, "<TITLE", 6)) {
					isTag = 0;
					isTitle = 1;
				}
				else if (isTitle && !strncscmp (sp, "</TITLE>", 8))
					isTitle = 0;
				else if (isMozilla == 2 && !isFrame && !strncscmp (sp, "<FRAME ", 7)) {
					isFrame = 1;
					initDone = 2;
				}
				else if (!isHtml && !strncscmp (sp, "<HTML", 5))
					isHtml = 1;
				else if (isHtml && !strncscmp (sp, "</HTML>", 7)) {
					isHtml = 0;
					if (initDone == 1) {
						if (0 < CII_O.showcp) {
							sprintf (dp, "%s", ShowCP (formbuf));
							dp += strlen (dp);
						}
						initDone = 2;
					}

				}
		}
		if (isComment)
			if (!strncmp (sp, "-->", 3)) {
				*dp++ = *sp++;
				*dp++ = *sp++;
				*dp++ = *sp++;
				isComment = 0;
				continue;
			}
			else {
				*dp++ = *sp++;
			}
		else if (isTag || isTitle || isScript) {
			if (*sp == '>') {
				*dp++ = *sp++;
				if (isTag)
					isTag = 0;
				if (isFrame)
					isFrame = 0;
			}
			else {
				if (CII_O.showcp && isFrame && !strncasecmp (sp, "NORESIZE", 8))
					sp += 8;
				*dp++ = *sp++;
			}
		}
		else if (CII_O.isplain) {
			switch (*sp) {
			case '<':
				sprintf (dp, "&lt;");
				dp += 4;
				sp++;
				break;
			case '>':
				sprintf (dp, "&gt;");
				dp += 4;
				sp++;
				break;
			case '&':
				sprintf (dp, "&amp;");
				dp += 5;
				sp++;
				break;
			case '"':
				sprintf (dp, "&quot;");
				dp += 6;
				sp++;
				break;
			default:
				*dp++ = *sp++;
				break;
			}
		}
		else
			*dp++ = *sp++;
	}
	*dp = 0;
	if (TagBufLen) {
		TagBufLen = 0;
		if (ignoreTagBuf)
			goto SRC_conv;
	}
}

#define ESC     '\033'
#define TO96    ','
#define TO2B    '$'
#define TO94    '('
#define TOASC1  'B'
#define TOASC2  'J'
#define TOASC3  'H'
#define TOGB    'A'
#define TOJP    'B'
#define TOJPOLD '@'
#define TOKSP   'D'
#define TOKR    'C'
#define TOCNS1  'G'
#define TOCNS2  'H'
#define TOCNS3  'I'
#define TOCNS4  'J'
#define TOCNS5  'K'
#define TOCNS6  'L'
#define TOCNS7  'M'
#define TOBIG51 '0'
#define TOBIG52 '1'
#define TOETHIO '2'
#define TOLTN1  'A'
#define TOLTN2  'B'
#define TOLTN3  'C'
#define TOLTN4  'D'
#define TOCYR   'L'
#define TOARA   'G'
#define TOGRE   'F'
#define TOHEB   'H'
#define TOLTN5  'M'
#define TOTHAI  'T'
#define TOVIET  '1'
#define TORK    'I'
#define TOARAB0	'2'
#define TOARAB1	'3'
#define TOARAB2	'4'
#define R2L1    '['
#define R2L3    ']'
#define R2LIN   '2'
#define R2LOUT  '0'
#define TOG0    '0'
#define TOG1    '1'

static
ISO2022_TO_CII (src, dst, ctype, charset, ubase)
	unsigned char *src, *dst;
	char *ctype, *charset, *ubase;
{
	unsigned char *tmpbuf, *csnbuf, *tmpdst, *euc;
	register unsigned char *sp, *dp, *cp;
	static char *Charsets[] =
	{
		"jp", "jp", "ksp", "kr", "gb", "big5", "ethio",
		"cns1", "cns2", "cns3", "cns4", "cns5", "cns6", "cns7",
		"ltn1", "ltn2", "ltn3", "ltn4", "cyr", "ara",
		"gre", "heb", "ltn5", "viet", "thai",
		"rk", "arab0", "arab1", "arab2", 0};
	enum {
		csn_nocvt = -1, csn_ascii,
		csn_jp, csn_ksp, csn_kr, csn_gb, csn_big5, csn_ethio,
		csn_cns1, csn_cns2, csn_cns3, csn_cns4, csn_cns5, csn_cns6, csn_cns7,
		csn_ltn1, csn_ltn2, csn_ltn3, csn_ltn4, csn_cyr, csn_ara,
		csn_gre, csn_heb, csn_ltn5, csn_viet, csn_thai,
		csn_rk, csn_arab0, csn_arab1, csn_arab2
	};

	int csn = 0, csnprev = 0, isR2L = 0, isR2Lprev = 0, isEUC = 0;
	int isLAP = 0, toCII, isTHAI, isBIG5, lcBIG5, escseq_len;

	isTHAI = (CharsetID (charset) == CharsetID ("th"));
	isBIG5 = (CharsetID (charset) == CharsetID ("big5"));
	tmpdst = dst;
	sp = src;
	dp = tmpbuf = (unsigned char *) malloc (strlen (src) + 1);
	cp = csnbuf = (unsigned char *) malloc (strlen (src) + 1);

	for (;;) {
		toCII = 0;
		if (*sp == 0)
			toCII = 1;
		else if (isR2Lprev) {
			if (!isR2L)
				toCII = 1;
		}
		else if (*sp == ESC)
			toCII = 1;
		else if (isEUC) {
			if (*sp <= 0x7F)
				toCII = 1;
			else if (isTHAI) {
				if (*sp == 0xD1 || *sp >= 0xD4 && *sp <= 0xDA || *sp >= 0xE7 && *sp <= 0xEE);
				else
					toCII = 1;
			}
		}
		else if (*sp >= 0x80)
			toCII = 1;




		if (toCII) {
			*dp = 0;
			if (isR2Lprev) {
				int csnR2L;
				unsigned char *buf = (unsigned char *) malloc (strlen (tmpbuf) + 1);
				unsigned char *bp = buf;
				while (dp > tmpbuf) {
					*bp++ = *--dp;
					csnR2L = *--cp;
					if (csnR2L != *(cp - 1) || dp == tmpbuf) {
						*bp = 0;
						if (csnR2L > 0)
							GIFCII_putCII (tmpdst, buf, ubase, Charsets[csnR2L], 0);
						else
							strcpy (tmpdst, buf);
						tmpdst += strlen (tmpdst);
						bp = buf;
					}
				}
				free (buf);
				cp = csnbuf;
			}
			else if (isEUC) {
				if (isComment || isTag || isTitle || isScript)
					strcpy (tmpdst, tmpbuf);
				else
					GIFCII_putCII (tmpdst, tmpbuf, ubase, charset, isTHAI && tmpbuf[1]);
			}
			else if (csn > 0)
				GIFCII_putCII (tmpdst, tmpbuf, ubase, Charsets[csn], isLAP);
			else if (csn == csn_nocvt)
				strcpy (tmpdst, tmpbuf);
			else
				ASCII_TO_CII (tmpbuf, tmpdst);
			tmpdst += strlen (tmpdst);
			dp = tmpbuf;
			if (*sp == 0)
				break;
		}

		isR2Lprev = isR2L;
		csnprev = csn;
		if (*sp == ESC) {
			escseq_len = 0;
			if (sp[1] == TO2B) {
				escseq_len = sp[2] == TO94 ? 4 : 3;
				switch (sp[escseq_len - 1]) {
				case TOJP:
				case TOJPOLD:
					csn = csn_jp;
					break;
				case TOKSP:
					csn = csn_ksp;
					break;
				case TOKR:
					csn = csn_kr;
					break;
				case TOGB:
					csn = csn_gb;
					break;
				case TOBIG51:
					csn = csn_big5;
					lcBIG5 = 0;
					break;
				case TOBIG52:
					csn = csn_big5;
					lcBIG5 = 1;
					break;
				case TOETHIO:
					csn = csn_ethio;
					break;
				case TOCNS1:
					csn = csn_cns1;
					break;
				case TOCNS2:
					csn = csn_cns2;
					break;
				case TOCNS3:
					csn = csn_cns3;
					break;
				case TOCNS4:
					csn = csn_cns4;
					break;
				case TOCNS5:
					csn = csn_cns5;
					break;
				case TOCNS6:
					csn = csn_cns6;
					break;
				case TOCNS7:
					csn = csn_cns7;
					break;
				default:
					csn = csn_nocvt;
				}
			}
			else if (sp[1] == TO94) {
				escseq_len = 3;
				switch (sp[2]) {
				case TORK:
					csn = csn_rk;
					break;
				case TOARAB0:
					csn = csn_arab0;
					break;
				case TOARAB1:
					csn = csn_arab1;
					break;
				case TOARAB2:
					csn = csn_arab2;
					break;
				case TOASC1:
				case TOASC2:
				case TOASC3:
					csn = csn_ascii;
					break;
				default:
					csn = csn_nocvt;
				}
			}
			else if (sp[1] == TO96) {
				escseq_len = 3;
				switch (sp[2]) {
				case TOLTN1:
					csn = csn_ltn1;
					break;
				case TOLTN2:
					csn = csn_ltn2;
					break;
				case TOLTN3:
					csn = csn_ltn3;
					break;
				case TOLTN4:
					csn = csn_ltn4;
					break;
				case TOCYR:
					csn = csn_cyr;
					break;
/*
   case TOARA:
   csn = csn_ara;
   break;
 */
				case TOGRE:
					csn = csn_gre;
					break;
				case TOHEB:
					csn = csn_heb;
					break;
				case TOLTN5:
					csn = csn_ltn5;
					break;
				case TOTHAI:
					csn = csn_thai;
					break;
				case TOVIET:
					csn = csn_viet;
					break;
				default:
					csn = csn_nocvt;
				}
			}
			else if (sp[1] == TOG0 || sp[1] == TOG1) {
				isLAP = (sp[1] == TOG0);
				sp += 2;
			}
			else if (sp[1] == R2L1 && sp[2] == R2LIN && sp[3] == R2L3) {
				sp += 4;
				isR2L = 1;
			}
			else if (sp[1] == R2L1 && sp[2] == R2LOUT && sp[3] == R2L3) {
				sp += 4;
				isR2L = 0;
			}
			else
				*dp++ = *sp++;

			if (escseq_len) {
				if (csn == csn_ascii) {
					if (csnprev == csn_nocvt) {
						*tmpdst++ = *sp++;
						*tmpdst++ = *sp++;
						*tmpdst++ = *sp++;
						*tmpdst = 0;
					}
					else
						sp += escseq_len;
				}
				else {
					if (csn > 0) {
						if (!isR2L && CharsetID (Charsets[csn]) == -1)
							csn = csn_nocvt;
						if (isComment || isTag || isTitle || isScript)
							csn = csn_nocvt;
					}
					if (csn <= 0)
						*dp++ = *sp++;
					else {
						sp += escseq_len;
						if (csnprev == csn_nocvt) {
							strcpy (tmpdst, "\033(B");
							tmpdst += strlen (tmpdst);
						}
					}
				}
			}
		}
		else if (*sp >= 0x80) {
			isEUC = 1;
			*dp++ = *sp++;
			if (isBIG5 && sp[1])
				*dp++ = *sp++;
		}
		else if (csn == csn_big5 && sp[1]) {
			isEUC = 0;
			{
				unsigned int temp_i = (sp[0] - 0x21) * (0xFF - 0xA1) + (sp[1] - 0x21);
				if (lcBIG5 == 1)
					temp_i += (0xFF - 0xA1 + 0x7F - 0x40) * (0xC9 - 0xA1);
				dp[0] = temp_i / (0xFF - 0xA1 + 0x7F - 0x40) + 0xA1;
				dp[1] = temp_i % (0xFF - 0xA1 + 0x7F - 0x40);
				dp[1] += dp[1] < 0x3F ? 0x40 : 0x62;
				sp += 2;
				dp += 2;
			}
		}
		else {
			isEUC = 0;
			if (isR2L)
				*cp++ = csn;
			*dp++ = (csn > 0 && *sp <= 0x7f) ? *sp | 0x80 : *sp;
			sp++;
		}
	}
	free (tmpbuf);
	free (csnbuf);
}

static
HZ_TO_CII (src, dst, ctype, ubase)
	unsigned char *src, *dst;
	char *ctype, *ubase;
{
	unsigned char *tmpbuf, *tmpdst;
	register unsigned char *sp, *dp;
	int inHZ = 0, inHZprev, toCII, c, len;

	tmpdst = dst;
	tmpbuf = (unsigned char *) malloc (strlen (src) + 1);
	for (sp = src, dp = tmpbuf; *sp;) {
		inHZprev = inHZ;
		toCII = 0;
		len = 1;
		c = *sp;

		if (c == '~') {
			if (sp[1] == '}') {
				inHZ = 0;
				len = 0;
				sp += 2;
				toCII = 1;
			}
			else if (sp[1] == '{') {
				inHZ = 1;
				len = 0;
				sp += 2;
				toCII = 1;
			}
			else if (sp[1] == '~')
				sp++;
		}
		else if (c == '&') {
			if (!strncmp (sp, "&lt;", 4)) {
				len = 4;
				c = '<';
			}
			else if (!strncmp (sp, "&gt;", 4)) {
				len = 4;
				c = '>';
			}
			else if (!strncmp (sp, "&amp;", 5)) {
				len = 5;	/* c = '&'; */
			}
			else if (!strncmp (sp, "&quot;", 6)) {
				len = 6;
				c = '\"';
			}
		}

		if (len) {
			if (inHZ && c <= 0x7f)
				c |= 0x80;
			*dp++ = c;
			sp += len;
		}

		if (toCII || !sp[1]) {
			*dp = '\0';
			if (inHZprev)
				GIFCII_putCII (tmpbuf, tmpdst, ubase, "gb", 0);
			else
				ASCII_TO_CII (tmpbuf, tmpdst);
			tmpdst += strlen (tmpdst);
			dp = tmpbuf;
		}
	}
	free (tmpbuf);
}

static char *
chcode (str)
	unsigned char *str;
{
	unsigned char *s, ch;
	int n8, n8s, nhz;

	n8 = 0;
	n8s = 0;
	nhz = 0;

	for (s = str; ch = *s; s++) {
		if (ch == '~')
			if (s[1] == '{' || s[1] == '}')
				nhz++;

		if (ch & 0x80) {
			n8++;
			n8s++;
		}
		else {
			if (n8 % 2 != 0)
				return "big5";
			n8 = 0;
		}
	}
	if (2 <= nhz)
		return "hz";
	if (0 < n8s)
		return "gb";
	return "jp";
}


static int
CIIinit (charset, ctype, modifier)
	char *charset, *ctype, *modifier;
{

	char URLOptions[128], *IFptr;
	char UserAGENT[1024], *mozi;
	char *i;
	int fromcp = 0;

	if (strncasecmp (ctype, "text/", 5) == 0 || !ctype[0])
		if (strncasecmp (ctype, "text/plain", 10) == 0)
			CII_O.isplain = 1;
		else
			CII_O.isplain = 0;
	else {
		CII_O.isplain = -1;
		return;
	}

	strcpy(UserAGENT,getenv("HTTP_USER_AGENT"));
	if (strstr (UserAGENT, "Emacs-W3")
	    || strstr (UserAGENT, "Lynx")
	    || strstr (UserAGENT, "CERN-LineMode")) {
		CII_O.istua = 1;
		return;
	}
	else
		CII_O.istua = 0;

	if ((mozi = (char *) strstr (UserAGENT, "Mozilla")) && strcmp (mozi, "Mozilla/1.1") >= 0)
		if (strcmp (mozi, "Mozilla/2.0") >= 0)
			isMozilla = 2;
		else
			isMozilla = 1;
	else {
		isMozilla = 0;
		lkColor = 0x0000b0;
	}


	CII_O.gwidth = GIFWIDTH;
#ifdef UNDERLINE
	CII_O.uline = 1;
#endif
#ifdef USPACE
	CII_O.uspc = 1;
#endif
#ifdef BLACKTXTASXBM
	CII_O.b2xbm = 1;
#endif
#ifdef LONGKANJIONLY
	CII_O.skana = 1;
#endif
#ifdef NOLONG256C
	CII_O.schar = 1;
#endif
#ifdef SHOWCP
	CII_O.showcp = 1;
#endif
	CII_O.charcode = charset;

	if (modifier[0]) {
		strcpy (CII_FLAGS, modifier);

		for (i = CII_FLAGS; *i; i++) {
			if (isupper (*i))
				*i = tolower (*i);
		}

		IFptr = CII_FLAGS;

		{
			if (*IFptr == '&') {
				IFptr++;
				strcpy (URLOptions, IFptr);

				fromcp = 1;

				if ((IFptr = strstr (URLOptions, "gw=")) != 0) {
					IFptr += 3;
					CII_O.gwidth = atoi (IFptr);
					if (CII_O.gwidth < 1 || CII_O.gwidth > GIFWIDTH)
						CII_O.gwidth = GIFWIDTH;
				}

				if ((IFptr = strstr (URLOptions, "ul=")) != 0) {
					IFptr += 3;
					CII_O.uline = (*IFptr == 'y') ? 1 : ((*IFptr == 'n') ? 0 : CII_O.uline);
				}
				else if (fromcp)
					CII_O.uline = 0;

				if ((IFptr = strstr (URLOptions, "us=")) != 0) {
					IFptr += 3;
					CII_O.uspc = (*IFptr == 'y') ? 1 : ((*IFptr == 'n') ? 0 : CII_O.uspc);
				}
				else if (fromcp)
					CII_O.uspc = 0;

				if ((IFptr = strstr (URLOptions, "bx=")) != 0) {
					IFptr += 3;
					CII_O.b2xbm = (*IFptr == 'y') ? 1 : ((*IFptr == 'n') ? 0 : CII_O.b2xbm);
				}
				else if (fromcp)
					CII_O.b2xbm = 0;

				if ((IFptr = strstr (URLOptions, "sk=")) != 0) {
					IFptr += 3;
					CII_O.skana = (*IFptr == 'y') ? 1 : ((*IFptr == 'n') ? 0 : CII_O.skana);
				}
				else if (fromcp)
					CII_O.skana = 0;

				if ((IFptr = strstr (URLOptions, "sc=")) != 0) {
					IFptr += 3;
					CII_O.schar = (*IFptr == 'y') ? 1 : ((*IFptr == 'n') ? 0 : CII_O.schar);
				}
				else if (fromcp)
					CII_O.schar = 0;

				if ((IFptr = strstr (URLOptions, "cp=")) != 0) {
					IFptr += 3;
					CII_O.showcp = (*IFptr == 'y') ? 1 : ((*IFptr == 'n') ? 0 : CII_O.showcp);
				}
				else if (fromcp)
					CII_O.showcp = 0;
			}
		}
	}
}


static int
isISO2022 (str)
	char *str;
{
	char *s;

	for (s = str; *s; s++) {
		if (*s == 033) {
			if (s[1] == '$' || s[1] == '(' || s[1] == ',')
				return 1;
		}
	}

	return 0;
}

static
_CII_toCII (any, gr, ctype, charsets, ubase, srcurl)
	unsigned char *any, *gr;
	char *ctype, *charsets[];
	char *ubase, *srcurl;
{
	unsigned char *euc;
	int i, strC;
	char *charsetsII;
	static char prevctype[128];
	char *cp, *sp, *modifier;

	if (gotEOF || strncasecmp (ctype, prevctype, strlen (ctype) + 1)) {
		initDone = 0;
		strcpy (prevctype, ctype);
		gotEOF = 0;
	}

	if (any[0] == 0) {	/* empty string from the caller indicates EOF */
		gotEOF = 1;
	}

	if (!initDone)
		cp = URLcharcode;
	else
		cp = NULL;
	sp = charsets[0];
	if (strncmp (sp, "cc=", 3) == 0)
		sp += 3;
	for (; *sp; sp++) {
		if (!isalnum (*sp))
			break;
		else if (cp)
			*cp++ = *sp;
	}
	if (cp)
		*cp = 0;
	modifier = sp;

	if (!initDone) {
		CIIinit (URLcharcode, ctype, modifier);
		initDone = 1;
	}

	if (CII_O.isplain < 0 || CII_O.istua || *CII_O.charcode == 0) {
		strcpy (gr, any);
		return;
	}


	if (isKOI != 2 && CharsetID ("koi8") != -1)
		isKOI = 2;
	else if (!strncasecmp (CII_O.charcode, "koi8", 4))
		isKOI = 1;
	else
		isKOI = 0;

	if (strcasecmp (CII_O.charcode, "cn") == 0) {
		charsetsII = chcode (any);
		if (charsetsII[0] == 'h')
			HZ_TO_CII (any, gr, ctype, ubase);
		else		/* Big5 or GB or ISO2022 */
			ISO2022_TO_CII (any, gr, ctype, charsetsII, ubase);
	}
	else if (!isISO2022 (any) && CharsetID (CII_O.charcode) == CharsetID ("jp")) {
		/* EUC-JP or SJIS */
		euc = (unsigned char *) malloc (strlen (any) + 1);
		TO_EUC (any, euc);
		ISO2022_TO_CII (euc, gr, ctype, CII_O.charcode, ubase);
		free (euc);
	}
	else
		ISO2022_TO_CII (any, gr, ctype, CII_O.charcode, ubase);
}

static int
CII_INFO (tc, vno, iname)
	FILE *tc;
	char *iname;
{
	char infobuf[5000];
	char useragentbuf[1024];
	static char *y = "Yes", *n = "No";
	int leng = 0;
	strcpy(useragentbuf,getenv("HTTP_USER_AGENT"));

	CIIinit ("", "text/html", "");


	sprintf (infobuf, "\
<TITLE>CIILIB Information</TITLE>\n\
<p><h1><center>Welcome to CIILIB %s!!!</center></h1>\n\
<hr><pre><strong>\n\
CharCode:           %s\n\
Image Width:        %d\n\
Underlined Anchors: %s\n\
Underlined Spaces:  %s\n\
Black Text as XBM:  %s\n\
Short Kana:         %s\n\
Short Chars:        %s\n\
Show Control Panel: %s\n\
User-Agent:         %s\n\
</strong></pre><hr><h2>Thanks !</h2>\n\
<br><address>\n\
<a href=\"mailto:valentin@rs.aubg.bg\">\n\
valentin@rs.aubg.bg(Valentin Shopov)\n\
</a>\n\
</address>\n\0\
", CIIVER, URLcharcode, CII_O.gwidth, ((CII_O.uline) ? y : n), ((CII_O.uspc) ? y : n), ((CII_O.b2xbm) ? y : n), ((CII_O.skana) ? y : n), ((CII_O.schar) ? y : n), ((CII_O.showcp) ? y : n), useragentbuf);

	leng += strlen (infobuf);
	fprintf (tc, "Content-Type: text/html\r\n");
	fprintf (tc, "Content-Length: %d\r\n", leng);
	fprintf (tc, "X-CII-Version: %s\r\n", CIIVER);
	fprintf (tc, "\r\n");
	fputs (infobuf, tc);
	return leng;

}

/*
 *    CII font server
 */
CII_putHTTP (out, cii_code)
	FILE *out;
	char *cii_code;
{
	char *inf;
	if (!strcasecmp (cii_code, "info"))
		return CII_INFO (out, 0, cii_code);
	else
		return CII_putHTTP_GIF (out, 0, cii_code);
}
