/************************************************************************
* Copyright (c) 1995 Valentin Shopov, Blagoevgrad, Bulgaria             *
*                                                                       *
* Permission to use, copy, modify, and distribute this material for any *
* purpose and without fee is hereby granted, provided that the above    *
* copyright notice and this permission notice appear in all copies, and *
* that the name of the author not be used in advertising or publicity   *
* pertaining to this material without the specific, prior written       *
* permission of the author.                                             *
*                                                                       *
* THE AUTHOR MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY *
* OF THIS MATERIAL FOR ANY PURPOSE. IT IS PROVIDED "AS IS", WITHOUT ANY *
* EXPRESS OR IMPLIED WARRANTIES.                                        *
*************************************************************************/

/**************************ciilib2.1.7***********************************
 *                                                                      *
 *        Character to Inline Image Conversion Library (CIILIB)         *
 *                                                                      *
 *         	  x16 and x14 CII Fonts Builder.			*
 *                      by Valentin Shopov                              *
 *                      valentin@rs.aubg.bg                             *
 ************************************************************************/


#include <stdio.h>
#include "cii.h"


#define DELIMITER "--\r\n"

extern struct CharCodesXBM CII_CC[];
extern int CII_CC_SIZE;
extern int CII_putFont1X ();



main (ac, av)
	char *av[];
{
	int i, leng, leng1;
	FILE *ciif;
	struct CharCodesXBM *csx;


	if (ac < 2) {
		fprintf (stderr, "Usage: %s  <CII Fonts File Full Path>\n", av[0]);
		exit (1);
	}


	ciif = fopen (av[1], "w+");
	if (ciif == NULL) {
		fprintf (stderr, "Error opening \"%s\"!\n", av[1]);
		exit (1);
	}

	for (i = 0, leng = 0; CII_CC[i].regname; i++) {
		csx = &CII_CC[i];
		leng += leng1 = CII_putFont1X (csx, ciif);
		fputs (DELIMITER, ciif);
		fprintf (stderr, "%s: %d (%s)\n", csx->regname, leng1, csx->name);

	}
	fclose (ciif);
	fprintf (stderr, "total: %d\n", leng);
	exit (0);

}
